var webdriver = require('selenium-webdriver'),
    By = webdriver.By,
    until = webdriver.until;
var test = require('selenium-webdriver/testing'); // works for Selenium V3
var assert = require('assert');

var driver;
const timeOut = 5000;
const site_url = process.env.BASE_URL || 'https://travel.agileway.net';

String.prototype.contains = function(it) {
  return this.indexOf(it) != -1;
};

describe('User Authentication', function() {

  before(async function() {
    this.timeout(timeOut);
    driver = new webdriver.Builder().forBrowser('chrome').build();
    driver.manage().window().setSize(1024, 700);
    driver.manage().window().setPosition(30, 78);
  });

  beforeEach(async function() {
    this.timeout(timeOut);
    driver.get(site_url);
  });

  after(async function() {
    driver.quit();
  });

  test.it('Invalid user', function() {
    this.timeout(timeOut);
    driver.findElement(webdriver.By.name('username')).sendKeys('agileway');
    driver.findElement(webdriver.By.name('password')).sendKeys('badpass');
    driver.findElement(webdriver.By.name('commit')).click();
    driver.getPageSource().then(function(page_source) {
      assert(page_source.contains("Invalid email or password"))
    });
  });

  test.it('User can login successfully', function() {
    this.timeout(timeOut);
    driver.findElement(webdriver.By.name('username')).sendKeys('agileway');
    driver.findElement(webdriver.By.name('password')).sendKeys('testwise');
    driver.findElement(webdriver.By.name('commit')).click();
    driver.getPageSource().then(function(page_source) {
      assert(page_source.contains("Welcome"))
    });
    driver.findElement(By.linkText("Sign off")).click();
  });


});
