load File.dirname(__FILE__) + '/../test_helper.rb'

describe "Select Flights" do
  include TestHelper

  before(:all) do
    @driver = $driver = Selenium::WebDriver.for(browser_type, browser_options)
    driver.manage().window().resize_to(1024, 700)
    driver.manage().window().move_to(30, 78)
    driver.get(site_url)
    
    driver.find_element(:id, "username").send_keys("agileway")
    driver.find_element(:id, "password").send_keys("testwise")
    driver.find_element(:id, "username").submit
  end

  before(:each) do
    goto_page("/")
    sleep 1 # for some webdriver verson, it might not wait page loaded
  end

  after(:all) do
    driver.quit unless debugging?
  end

  it "[3] Return trip" do
    driver.find_elements(:name => "tripType").each { |elem| elem.click && break if elem.attribute("value") == "return" && elem.attribute("type") == "radio" }
    Selenium::WebDriver::Support::Select.new(driver.find_element(:name, "fromPort")).select_by(:text, "Sydney")
    Selenium::WebDriver::Support::Select.new(driver.find_element(:name, "toPort")).select_by(:text, "New York")
    Selenium::WebDriver::Support::Select.new(driver.find_element(:id, "departDay")).select_by(:text, "02")
    Selenium::WebDriver::Support::Select.new(driver.find_element(:id, "departMonth")).select_by(:text, "May #{Date.today.year}")
    Selenium::WebDriver::Support::Select.new(driver.find_element(:id, "returnDay")).select_by(:text, "04")
    Selenium::WebDriver::Support::Select.new(driver.find_element(:id, "returnMonth")).select_by(:text, "June #{Date.today.year}")
    driver.find_element(:xpath,"//input[@value='Continue']").click

    expect(page_text).to include("#{Date.today.year}-05-02 Sydney to New York")
    expect(page_text).to include("#{Date.today.year}-06-04 New York to Sydney")
  end

  it "[2] One-way trip" do
    driver.find_element(:xpath, "//input[@name='tripType' and @value='oneway']").click
    Selenium::WebDriver::Support::Select.new(driver.find_element(:name, "fromPort")).select_by(:text, "Sydney")
    Selenium::WebDriver::Support::Select.new(driver.find_element(:name, "toPort")).select_by(:text, "New York")
    Selenium::WebDriver::Support::Select.new(driver.find_element(:id, "departDay")).select_by(:text, "02")
    Selenium::WebDriver::Support::Select.new(driver.find_element(:id, "departMonth")).select_by(:text, "May #{Date.today.year}")
    driver.find_element(:xpath,"//input[@value='Continue']").click

    expect(page_text).to include("#{Date.today.year}-05-02 Sydney to New York")
  end

end
