load File.dirname(__FILE__) + '/../test_helper.rb'
require "net/http"
require "net/https"

describe "Soap" do
  include TestHelper

  before(:all) do    
  end

  after(:all) do
  end

  #   <?xml version="1.0" encoding="utf-8"?>
  #  Unexpected XML declaration. The XML declaration must be the first node in the document, and no white space characters are allowed to appear before it.
  it "SOAP 1.2 with sample XML" do
    request_xml = <<END_OF_MESSAGE
<?xml version="1.0" encoding="utf-8"?>
<soap12:Envelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:soap12="http://www.w3.org/2003/05/soap-envelope">
  <soap12:Body>
    <CelsiusToFahrenheit xmlns="https://www.w3schools.com/xml/">
      <Celsius>20</Celsius>
    </CelsiusToFahrenheit>
  </soap12:Body>
</soap12:Envelope>
END_OF_MESSAGE

    # http = Net::HTTP.new('www.w3schools.com', 443)
    uri = URI.parse("https://www.w3schools.com/xml/tempconvert.asmx")
    http = Net::HTTP.new(uri.host, uri.port)
    http.use_ssl = true
    resp, data = http.post(uri.path, request_xml,
      { "SOAPAction": "https://www.w3schools.com/xml/CelsiusToFahrenheit",
        "Content-Type": "text/xml",
        "Host": "www.w3schools.com"})
    puts resp.body
    expect(resp.code).to eq("200") # OK
    # debug resp.body
    # resp.each { |key, val| debug(key + ' = ' + val) }
    expect(resp.body).to include("<CelsiusToFahrenheitResult>68</CelsiusToFahrenheitResult>")
  end

end
