# require 'rubygems'
gem "appium_lib"

require "appium_lib"
require "rspec"

# include utility functions such as 'page_text', 'try_for', 'fail_safe', ..., etc.
require "#{File.dirname(__FILE__)}/agileway_utils.rb"

# when running in TestWise, it will auto load TestWiseRuntimeSupport, ignore otherwise
if defined?(TestWiseRuntimeSupport)
  ::TestWise::Runtime.load_webdriver_support # for selenium webdriver support
end

# this loads defined page objects under pages folder
require "#{File.dirname(__FILE__)}/pages/abstract_window.rb"
Dir["#{File.dirname(__FILE__)}/pages/*_window.rb"].each { |file| load file }
Dir["#{File.dirname(__FILE__)}/pages/*_dialog.rb"].each { |file| load file }


# This is the helper for your tests, every test file will include all the operation
# defined here.
module TestHelper
  include AgilewayUtils
  if defined?(TestWiseRuntimeSupport) # TestWise 5+
    include TestWiseRuntimeSupport
  end

  def driver
    @driver
  end
  
  def calculator_app_id
    "Microsoft.WindowsCalculator_8wekyb3d8bbwe!App"
  end
  
  def calculator_app_caps
    desired_caps = {
      caps: {
        platformName: "Windows",
        platform: "Windows",
        deviceName: "MyPC",
        app: calculator_app_id(),
      },
      appium_lib: { wait: 0.5 },
    }
  end
  
    def notepad_caps
    @desired_caps = {
      caps: {
        platformName: "Windows",
        deviceName: "SurfacePro",
        app: "notepad.exe",
      },
    }
  end

  def debugging?
    return ENV["RUN_IN_TESTWISE"].to_s == "true" && ENV["TESTWISE_RUNNING_AS"] == "test_case"
  end

  # prevent extra long string generated test scripts that blocks execution when running in
  # TestWise or BuildWise Agent
  def safe_print(str)
    return if str.nil? || str.empty?
    if (str.size < 250)
      puts(str)
      return
    end

    if ENV["RUN_IN_TESTWISE"].to_s == "true" && ENV["RUN_IN_BUILDWISE_AGENT"].to_s == "true"
      puts(str[0..200])
    end
  end
end
